## org.apache.mahout.cf.taste.impl.similarity
Class CachingItemSimilarity

    java.lang.Object
      org.apache.mahout.cf.taste.impl.similarity.CachingItemSimilarity

All Implemented Interfaces:
  Refreshable, ItemSimilarity

    public final class CachingItemSimilarity

extends Object
implements ItemSimilarity

Caches the results from an underlying `ItemSimilarity` implementation.

Constructor Summary
`CachingItemSimilarity(ItemSimilarity similarity, DataModel dataModel)` Creates this on top of the given `ItemSimilarity`.
`CachingItemSimilarity(ItemSimilarity similarity, int maxCacheSize)` Creates this on top of the given `ItemSimilarity`.

Method Summary
`long[]` `allSimilarItemIDs(long itemID)`
`void` `clearCacheForItem(long itemID)`
`double[]` `itemSimilarities(long itemID1, long[] itemID2s)` A bulk-get version of `ItemSimilarity.itemSimilarity(long, long)`.
`double` `itemSimilarity(long itemID1, long itemID2)` Returns the degree of similarity, of two items, based on the preferences that users have expressed for the items.
`void` `refresh(Collection<Refreshable> alreadyRefreshed)` Triggers "refresh" -- whatever that means -- of the implementation.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CachingItemSimilarity

    public CachingItemSimilarity(ItemSimilarity similarity,
                                 DataModel dataModel)
                          throws TasteException

  Creates this on top of the given `ItemSimilarity`. The cache is sized according to properties of the given `DataModel`.

  Throws:
    `TasteException`

### CachingItemSimilarity

    public CachingItemSimilarity(ItemSimilarity similarity,
                                 int maxCacheSize)

  Creates this on top of the given `ItemSimilarity`. The cache size is capped by the given size.

Method Detail

### itemSimilarity

    public double itemSimilarity(long itemID1,
                                 long itemID2)
                          throws TasteException

  Description copied from interface: `ItemSimilarity`

  Returns the degree of similarity, of two items, based on the preferences that users have expressed for the items.

  Specified by:
    `itemSimilarity` in interface `ItemSimilarity`
  Parameters:
    `itemID1` - first item ID
    `itemID2` - second item ID
  Returns:
    similarity between the items, in [-1,1] or `Double.NaN` similarity is unknown
  Throws:
    `NoSuchItemException` - if either item is known to be non-existent in the data
    `TasteException` - if an error occurs while accessing the data

### itemSimilarities

    public double[] itemSimilarities(long itemID1,
                                     long[] itemID2s)
                              throws TasteException

  Description copied from interface: `ItemSimilarity`

  A bulk-get version of `ItemSimilarity.itemSimilarity(long, long)`.

  Specified by:
    `itemSimilarities` in interface `ItemSimilarity`
  Parameters:
    `itemID1` - first item ID
    `itemID2s` - second item IDs to compute similarity with
  Returns:
    similarity between itemID1 and other items
  Throws:
    `NoSuchItemException` - if any item is known to be non-existent in the data
    `TasteException` - if an error occurs while accessing the data

### allSimilarItemIDs

    public long[] allSimilarItemIDs(long itemID)
                             throws TasteException

  Specified by:
    `allSimilarItemIDs` in interface `ItemSimilarity`
  Returns:
    all IDs of similar items, in no particular order
  Throws:
    `TasteException`

### refresh

    public void refresh(Collection<Refreshable> alreadyRefreshed)

  Description copied from interface: `Refreshable`

  Triggers "refresh" -- whatever that means -- of the implementation. The general contract is that any `Refreshable` should always leave itself in a consistent, operational state, and that the refresh atomically updates internal state from old to new.

  Specified by:
    `refresh` in interface `Refreshable`
  Parameters:
    `alreadyRefreshed` - `Refreshable`s that are known to have already been refreshed as a result of an initial call to a `Refreshable.refresh(Collection)` method on some object. This ensure that objects in a refresh dependency graph aren't refreshed twice needlessly.

### clearCacheForItem

    public void clearCacheForItem(long itemID)

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.